%bcond_with debug

%if %{with debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%global provider        github
%global provider_tld    com
%global project         golang
%global repo            text
# https://github.com/golang/text
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global goipath         golang.org/x/text

Name:           golang-x-text
Version:        0.3.7
Release:        1%{?dist}
Summary:        Go text processing support

# Upstream license specification: BSD-3-Clause
License:        BSD
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/v%{version}/%{repo}-%{version}.tar.gz

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 aarch64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%description
Text is a repository of text-related packages related to internationalization
(i18n) and localization (l10n), such as character encodings, text
transformations, and locale-specific text handling.

%package devel
Summary:       %{summary}
BuildArch:     noarch

Provides:      golang(%{goipath}) = %{version}-%{release}
Provides:      golang(%{goipath}/cases) = %{version}-%{release}
Provides:      golang(%{goipath}/collate) = %{version}-%{release}
Provides:      golang(%{goipath}/collate/build) = %{version}-%{release}
Provides:      golang(%{goipath}/currency) = %{version}-%{release}
Provides:      golang(%{goipath}/date) = %{version}-%{release}
Provides:      golang(%{goipath}/encoding) = %{version}-%{release}
Provides:      golang(%{goipath}/encoding/charmap) = %{version}-%{release}
Provides:      golang(%{goipath}/encoding/htmlindex) = %{version}-%{release}
Provides:      golang(%{goipath}/encoding/ianaindex) = %{version}-%{release}
Provides:      golang(%{goipath}/encoding/internal) = %{version}-%{release}
Provides:      golang(%{goipath}/encoding/internal/enctest) = %{version}-%{release}
Provides:      golang(%{goipath}/encoding/internal/identifier) = %{version}-%{release}
Provides:      golang(%{goipath}/encoding/japanese) = %{version}-%{release}
Provides:      golang(%{goipath}/encoding/korean) = %{version}-%{release}
Provides:      golang(%{goipath}/encoding/simplifiedchinese) = %{version}-%{release}
Provides:      golang(%{goipath}/encoding/traditionalchinese) = %{version}-%{release}
Provides:      golang(%{goipath}/encoding/unicode) = %{version}-%{release}
Provides:      golang(%{goipath}/encoding/unicode/utf32) = %{version}-%{release}
Provides:      golang(%{goipath}/feature/plural) = %{version}-%{release}
Provides:      golang(%{goipath}/internal) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/catmsg) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/cldrtree) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/colltab) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/export/idna) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/export/unicode) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/format) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/gen) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/gen/bitfield) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/language) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/language/compact) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/number) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/stringset) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/tag) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/testtext) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/triegen) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/ucd) = %{version}-%{release}
Provides:      golang(%{goipath}/internal/utf8internal) = %{version}-%{release}
Provides:      golang(%{goipath}/language) = %{version}-%{release}
Provides:      golang(%{goipath}/language/display) = %{version}-%{release}
Provides:      golang(%{goipath}/message) = %{version}-%{release}
Provides:      golang(%{goipath}/message/catalog) = %{version}-%{release}
Provides:      golang(%{goipath}/number) = %{version}-%{release}
Provides:      golang(%{goipath}/runes) = %{version}-%{release}
Provides:      golang(%{goipath}/search) = %{version}-%{release}
Provides:      golang(%{goipath}/secure) = %{version}-%{release}
Provides:      golang(%{goipath}/secure/bidirule) = %{version}-%{release}
Provides:      golang(%{goipath}/secure/precis) = %{version}-%{release}
Provides:      golang(%{goipath}/transform) = %{version}-%{release}
Provides:      golang(%{goipath}/unicode) = %{version}-%{release}
Provides:      golang(%{goipath}/unicode/bidi) = %{version}-%{release}
Provides:      golang(%{goipath}/unicode/cldr) = %{version}-%{release}
Provides:      golang(%{goipath}/unicode/norm) = %{version}-%{release}
Provides:      golang(%{goipath}/unicode/rangetable) = %{version}-%{release}
Provides:      golang(%{goipath}/unicode/runenames) = %{version}-%{release}
Provides:      golang(%{goipath}/width) = %{version}-%{release}
Provides:      golang-ipath(%{goipath}) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{goipath} prefix.

%prep
%setup -q -n %{repo}-%{version}
rm -rf  message/pipeline/ cmd/gotext/
mkdir -p _build/src/%{dirname:%{goipath}}
ln -sr $(pwd) _build/src/%{goipath}

%build

%install
cd _build/src/%{goipath}
# source codes for building projects
install -d -p %{buildroot}/%{gopath}/src/%{goipath}/
echo "%%dir %%{gopath}/src/%%{goipath}/." >> devel.file-list
# find all *.s and generate devel.file-list
for file in $(find . -iname "*.s") ; do
    echo "%%dir %%{gopath}/src/%%{goipath}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{goipath}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{goipath}/$file
    echo "%%{gopath}/src/%%{goipath}/$file" >> devel.file-list
done
# find all *.c and generate devel.file-list
for file in $(find . -iname "*.c") ; do
    echo "%%dir %%{gopath}/src/%%{goipath}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{goipath}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{goipath}/$file
    echo "%%{gopath}/src/%%{goipath}/$file" >> devel.file-list
done
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    echo "%%dir %%{gopath}/src/%%{goipath}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{goipath}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{goipath}/$file
    echo "%%{gopath}/src/%%{goipath}/$file" >> devel.file-list
done

sort -u -o devel.file-list devel.file-list

%files devel -f devel.file-list
%license LICENSE PATENTS
%doc AUTHORS CONTRIBUTING.md CONTRIBUTORS README.md

%changelog
* Fri Jun 24 2022 Maxwell G <gotmax@e.email> - 0.3.7-1
- Update to 0.3.7. Fixes rhbz#1945761.
- Mitigate CVE-2021-38561 (rhbz#2100495).

* Thu Jan  7 22:40:20 CET 2021 Robert-André Mauchin <zebob.m@gmail.com> - 0.3.4-1.2
- Fix provides

* Thu Jan  7 20:57:02 CET 2021 Robert-André Mauchin <zebob.m@gmail.com> - 0.3.4-1.1
- Rebuild for EPEL8

* Sat Dec 26 13:36:24 CET 2020 Robert-André Mauchin <zebob.m@gmail.com> - 0.3.4-1
- Update to 0.3.4
- Close: rhbz#1847788

* Fri Aug 07 21:06:39 CEST 2020 Robert-André Mauchin <zebob.m@gmail.com> - 0.3.3-1
- Update to 0.3.3

* Sat Aug 01 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.2-8
- Second attempt - Rebuilt for
  https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.2-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.2-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Sun Aug 18 2019 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.3.2-5
- Update to latest version

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Jul 05 2019 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.3.0-4.20190416gitf4905fb
- Add Obsoletes for old name

* Tue Apr 16 00:29:58 CEST 2019 Robert-André Mauchin <zebob.m@gmail.com> - 0.3.0-3.20190416gitf4905fb
- Bump to commit f4905fbd45b6790792202848439271c74074bbfd

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Sat Oct 27 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0.3.0-1
- Update to release 0.3.0

* Tue Oct 23 2018 Nicolas Mailhot <nim@fedoraproject.org> - 0-0.26.git3bd178b
- redhat-rpm-config-123 triggers bugs in gosetup, remove it from Go spec files as it’s just an alias
- https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/message/RWD5YATAYAFWKIDZBB7EB6N5DAO4ZKFM/

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.25.git3bd178b
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Sun Mar 18 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0-0.24.git3bd178b
- Fix typo in package name

* Thu Mar 15 2018 Jan Chaloupka <jchaloup@redhat.com> - 0-0.23.git3bd178b
- Update to spec 3.0
- Fix test error reported by go1.10

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.22.git3bd178b
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Aug 24 2017 Jan Chaloupka <jchaloup@redhat.com> - 0-0.21.git3bd178b
- Bump to upstream 3bd178b88a8180be2df394a1fbb81313916f0e7b
  related: #1254601

* Fri Aug 11 2017 Athos Ribeiro <athoscr@fedoraproject.org> - 0-0.20.git65f4f82
- Bump to upstream 65f4f820a7954b82e5c9325e1e088a4fda098f36
- related: #1254601

* Wed Aug 02 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.19.git04b8648
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.18.git04b8648
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.17.git04b8648
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Fri Jan 13 2017 Jan Chaloupka <jchaloup@redhat.com> - 0-0.16.git04b8648
- Bump to upstream 04b8648d973c126ae60143b3e1473bc1576c7597
  related: #1254601

* Wed Dec 14 2016 Jan Chaloupka <jchaloup@redhat.com> - 0-0.15.git6fc2e00
- Polish the spec file
  related: #1254601

* Wed Aug 10 2016 jchaloup <jchaloup@redhat.com> - 0-0.14.git6fc2e00
- skip currency test on aarch64 (binaries have different size)
  resolves: #1365814

* Wed Jul 27 2016 jchaloup <jchaloup@redhat.com> - 0-0.13.git6fc2e00
- skip currency test on s390x (binaries have different size)
  resolves: #1360388

* Mon Jul 25 2016 jchaloup <jchaloup@redhat.com> - 0-0.12.git6fc2e00
- Polishing the spec file
  related: #1254601

* Thu Jul 21 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.11.git6fc2e00
- https://fedoraproject.org/wiki/Changes/golang1.7

* Tue Feb 23 2016 Peter Robinson <pbrobinson@fedoraproject.org> 0-0.10.git6fc2e00
- License and arch definition cleanup

* Mon Feb 22 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.9.git6fc2e00
- https://fedoraproject.org/wiki/Changes/golang1.6

* Fri Feb 19 2016 jchaloup <jchaloup@redhat.com> - 0-0.8.git6fc2e00
- Bump to upstream 6fc2e00a0d64b1f7fc1212dae5b0c939cf6d9ac4
  Repository has moved from code.google.com/p/go.text to github.com/golang/text
  related: #1254601

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.7.hg5b2527008a4c
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Aug 20 2015 jchaloup <jchaloup@redhat.com> - 0-0.6.hg5b2527008a4c
- Choose the correct devel subpackage
  related: #1254601

* Thu Aug 20 2015 jchaloup <jchaloup@redhat.com> - 0-0.5.hg5b2527008a4c
- Update spec file to spec-2.0
  resolves: #1254601

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.4.hg5b2527008a4c
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Tue Dec 09 2014 jchaloup <jchaloup@redhat.com> - 0-0.3.hg5b2527008a4c
- Update to the latest commit 5b2527008a4c8988ca9dc6f010ebfb9dae67150b
  related: #1056285

* Fri Nov 21 2014 jchaloup <jchaloup@redhat.com> - 0-0.2.hg024681b033be
- Extend import paths for golang.org/x/
- Choose the correct architecture
  related: #1056285

* Sun Sep 28 2014 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0-0.1.hg024681b033be
- Resolves: rhbz#1056285 - Initial package
